/**** ------------------------------------------------------------------- ****/
/**** Filename : maske.h        Written by Joachim Fricker                ****/
/****   Include File zu den Maskentools                                   ****/
/**** ------------------------------------------------------------------- ****/

/*	falls Parameter in_x < 0 ist wird die Maske Zentriert
	sonst werden die bergebenen Werte bernommen			
*/
int 	MaskeAnzeige ( OBJECT * tree , int in_x , int in_y ) ;

int 	MaskeClear ( OBJECT * tree ) ;

/* 	Maske wird an der alten Stelle neu gezeichnet 
	=> Aktuelle Werte sind sichtbar 				
*/
int 	MaskeDraw ( OBJECT * tree ) ;


/*	Setzt den Wert eines Editfeldes , vor dem Aufschalten der
	Maske zu verwenden
*/
char *  FSetText ( OBJECT *tree , int nummer, char * s ) ;

/*	Setzt den Wert eines angezeigten Editfeldes und 
	erzwingt ein Neuzeichnen
*/
char * 	FShowText ( OBJECT *tree , int num, char * s ) ;

/*	Ermitteln des Wertes von einem Editfeld 			
*/
char *  FGetText ( OBJECT *tree , int nummer ) ;

/*	Verndern des Zustandes eines Objektes im Objektbaum		
	Falls zustand = Selected oder zustand = Normal 
	wird der neue Zustand aus einer Oder Verknpfung berechnet
	=> grafische Attribute bleiben erhalten (siehe Knpfe)		
*/
void 	MaskeChange ( OBJECT * tree, int nummer ,int zustand) ;

/*	Simuliert das Lschen eines Editfeldes mittel ESC
	wird bei der Eingabe Maske verwender
*/
void 	FClear ( OBJECT *tree , int i) ;	

/*	Macht das Editfeld zum aktuellen Objekt 
*/
void 	FCurrent (OBJECT *tree,int i) ;	



